﻿package com{
	
	import flash.display.MovieClip;
	import flash.text.TextFormat;
	import flash.events.MouseEvent;
	import flash.events.Event;
	import flash.net.URLLoader;
	import flash.net.URLRequest;
	
	public class coinFlip extends MovieClip{
		
		private var randomFace:Number = 0;
		private var refCoinMC:MovieClip;
		private var refResultMC:MovieClip;
		private var stageWidth:Number = 760;
		private var resultsMC:MovieClip;
		private var normalTxtFormat:TextFormat = new TextFormat;
		private var clickedTxtFormat:TextFormat = new TextFormat;
		private var coinsPosArr:Array = [];
		private var coinsMC:MovieClip;
		private var noOfCoins:Number = 1;
		private var count:Number = 0;
		private var allCoinsFlipFlag:Boolean = false;
		
		public function coinFlip():void{
			coinsMC = new MovieClip;
			addChild(coinsMC);//coins movieclip
			resultsMC = new MovieClip;
			addChild(resultsMC);//results movieclip
			resultsMC.visible = false;
			noOfCoins_mc.visible = false;			
			
			/*hideShowResult_btn.hideResultTxt_mc.visible = false;
			setMCtoBtn(hideShowResult_btn);
			hideShowResult_btn.addEventListener(MouseEvent.MOUSE_UP, fnShowHideResult);*/		
			
			
			resultBut.addEventListener(MouseEvent.CLICK, fnShowHideResult);
			resultHideBut.addEventListener(MouseEvent.CLICK, fnShowHideResult);
			setMCtoBtn(resultHideBut)
			setMCtoBtn(resultBut)
			
			
			moreCoins_btn.addEventListener(MouseEvent.CLICK, fnShowHideNoOfCoins);
			setMCtoBtn(moreCoins_btn);
			flipAll_btn.buttonMode=true;
			flipAll_btn.addEventListener(MouseEvent.CLICK, fnFlipAllCoins);
			setMCtoBtn(flipAll_btn);
			//adding event for nos displayed when more button is clicked
			
			
			for(var i:Number = 0; i < 6; i++){
				var noMC:MovieClip = noOfCoins_mc.getChildByName("btn_" + i) as MovieClip;
				noMC.addEventListener(MouseEvent.CLICK, fnCoinNoClicked);
				setMCtoBtn(noMC);
			}
			normalTxtFormat.color = 0xffffff;
			clickedTxtFormat.color = 0x000000;
			//loading xml
			var xmlLoader:URLLoader = new URLLoader();
			xmlLoader.load(new URLRequest("xml/coins_flip.xml"));
			xmlLoader.addEventListener(Event.COMPLETE, fnLoadXML);
			reset_btn.addEventListener(MouseEvent.CLICK, reset);
			
			var MC=noOfCoins_mc.getChildByName("btn_0");
			MC.gotoAndStop(3);
			MC.isSelected=true;
		}
		
		
		private function onBtnEffectOver(eve):void 
		{
			if(!eve.target.isSelected){
				eve.target.gotoAndStop(2);
			}
		}
		
		private function onBtnEffectOut(eve):void 
		{
			if(!eve.target.isSelected){
				eve.target.gotoAndStop(1);
			}
		}
		
		private function fnLoadXML(eve:Event):void{
			var xml:XML = new XML(eve.target.data);
			for(var i:Number = 0; i < xml.coinPosition.pos.length(); i++){
				coinsPosArr.push(xml.coinPosition.pos[i].@XY);//pushing xy position in array
			}
			fnDisplayCoins();
		}
		
		//event triggered when no is clicked from movieclip displayed when more button is clicked
		private function fnCoinNoClicked(eve:MouseEvent):void {
			eve.target.isSelected = true;
			var noMC:MovieClip;
			for(var i:Number = 0; i < 6; i++){
				noMC = noOfCoins_mc.getChildByName("btn_" + i) as MovieClip;
				//noMC.txt.setTextFormat(normalTxtFormat);
				noMC.gotoAndStop(1);
				noMC.isSelected = false;
				
			}
			eve.target.isSelected = true;
			eve.target.gotoAndStop(3)
			//eve.target.txt.setTextFormat(clickedTxtFormat);
			noOfCoins = Number(eve.target.name.split("_")[1]) + 1;
			fnDisplayCoins();
		}
		
		//displays coins based on nos button clicked
		private function fnDisplayCoins():void{
			var XYPos:String = coinsPosArr[noOfCoins - 1];
			var XYPosArr:Array = XYPos.split(",");
			removeChildOf();
			for(var i:Number = 1; i <= noOfCoins; i++){
				var coinMC:MovieClip;
				var resultMC:MovieClip;
				if(coinsMC.getChildByName("coinMC_" + i) == null){//creates new coin if nos button clicked count is greater than coin displayed on stage
					coinMC = new coin_mc;					
					coinsMC.addChild(coinMC);
					coinMC.scaleX = .9;
					coinMC.scaleY = .9;
					coinMC.gotoAndStop(1);
					coinMC.name = "coinMC_" + i;
					
					resultMC = new result_mc;					
					resultsMC.addChild(resultMC);
					resultMC.name = "resultMC_" + i;
					resultMC.headCnt_txt.text = 0;
					resultMC.tailCnt_txt.text = 0;
					coinMC.addEventListener(MouseEvent.MOUSE_DOWN, fnFlipCoin);
				}else{//moves already the existing coin to the new position based on no of coins to display
					coinMC = coinsMC.getChildByName("coinMC_" + i) as MovieClip;
					resultMC = resultsMC.getChildByName("resultMC_" + i) as MovieClip;
				}
				coinMC.x = XYPosArr[i-1].split("_")[0];
				coinMC.y = XYPosArr[i-1].split("_")[1];
				resultMC.x = coinMC.x;
				resultMC.y = coinMC.y + (coinMC.height/2) + 5;				
			}
		}
		
		//event triggered when coin is clicked
		private function fnFlipCoin(eve:MouseEvent):void{
			allCoinsFlipFlag = false;
			var clip:MovieClip = eve.target as MovieClip;
			fnFlipCoinsDisplayFace(clip);
		}
		
		//event triggered when flipAllcoin button is clicked
		private function fnFlipAllCoins(eve:MouseEvent = null):void{
			flipAll_btn.mouseEnabled=false;
			allCoinsFlipFlag = true;			
			count++;
			if(count <= noOfCoins){
				var clip:MovieClip = coinsMC.getChildByName("coinMC_" + count) as MovieClip;
				fnFlipCoinsDisplayFace(clip);
			}else{
				flipAll_btn.mouseEnabled=true;
				allCoinsFlipFlag = false;			
				count = 0;
			}
		}
		
		//generates random face and triggers coin flip animation
		private function fnFlipCoinsDisplayFace(clip:MovieClip):void{
			randomFace = Math.ceil(Math.random() * 2);
			clip.gotoAndPlay(1);
			refCoinMC = clip;
			clip.addEventListener(Event.ENTER_FRAME, fnShowCoinFace);
			refResultMC = resultsMC.getChildByName("resultMC_" + clip.name.split("_")[1]) as MovieClip;
		}
		
		//coin flip animation
		private function fnShowCoinFace(eve:Event):void{
			if(eve.target.currentFrame == eve.target.totalFrames){//checks whether the coin flip animation reached the last frame
				eve.target.removeEventListener(Event.ENTER_FRAME, fnShowCoinFace)
				
				
				//based on random face generated, displayes the coin and updates the results
				if(randomFace == 1){
					refCoinMC.gotoAndStop(1);
					refResultMC.headCnt_txt.text = Number(refResultMC.headCnt_txt.text) + 1;
					flipAll_btn.mouseEnabled=true;
				}else{
					refCoinMC.gotoAndStop(6);
					refResultMC.tailCnt_txt.text = Number(refResultMC.tailCnt_txt.text) + 1;
					flipAll_btn.mouseEnabled=true;
				}
				if(allCoinsFlipFlag){
					if(count <= noOfCoins){
						fnFlipAllCoins();//loops back for animating coin - triggered when flipAllCoins button is clicked
					}	
				}
			}
			
		}
		public var flag:Boolean =false;
		//trigged when hide/show result button is clicked
		private function fnShowHideResult(eve:MouseEvent):void{
			var clip:MovieClip = eve.target as MovieClip;
			
			//based on text visible in the button result movieclip and text in the button are displayed or hidden
			if(flag){
				flag = false;
				resultBut.visible=true;
				resultHideBut.visible=false;
			}else{
				flag = true;
				resultBut.visible=false;
				resultHideBut.visible=true;
			}
				
			resultsMC.visible = flag;
			
		}
		
		//triggered when moreCoins button is clicked
		private function fnShowHideNoOfCoins(eve:MouseEvent):void{
			if(noOfCoins_mc.visible){
				noOfCoins_mc.visible = false;
			}else{
				noOfCoins_mc.visible = true;
			}
		}
		
		//removes the coins greater than no of coins clicked
		private function removeChildOf():void{
			for(var i:Number = coinsMC.numChildren-1; i >= noOfCoins; i--){
				coinsMC.removeChild(coinsMC.getChildAt(i));
				resultsMC.removeChild(resultsMC.getChildAt(i));
			}
		}
		
		//resets the results
		private function reset(eve:MouseEvent):void{
			for(var i:Number = 1; i <= noOfCoins; i++){
				var resultClip:MovieClip = resultsMC.getChildByName("resultMC_" + i) as MovieClip;
				resultClip.headCnt_txt.text = 0;
				resultClip.tailCnt_txt.text = 0;
			}
			noOfCoins = 1
			var noMC:MovieClip;
			for(i = 0; i < 6; i++){
				noMC = noOfCoins_mc.getChildByName("btn_" + i) as MovieClip;
				//noMC.txt.setTextFormat(normalTxtFormat);
				noMC.gotoAndStop(1);
				noMC.isSelected = false;
				
			}
			var MC=noOfCoins_mc.getChildByName("btn_0");
			MC.gotoAndStop(3);
			MC.isSelected=true;
			 fnDisplayCoins()
		}
		
		
		
		function setMCtoBtn(_tar) {
			_tar.gotoAndStop(1);
			_tar.mouseChildren=false;
			_tar.buttonMode=true;
			_tar.addEventListener(MouseEvent.MOUSE_DOWN,onBtnEffectDown);
			_tar.addEventListener(MouseEvent.MOUSE_OVER, onBtnEffectOver);
			_tar.addEventListener(MouseEvent.MOUSE_OUT, onBtnEffectOut);
			_tar.addEventListener(MouseEvent.MOUSE_UP,onBtnEffectUp);

			function onBtnEffectUp(eve):void {
				if (! eve.target.isSelected) {
					eve.target.gotoAndStop(1);
				}
			}

			function onBtnEffectOver(eve):void {
				if (! eve.target.isSelected) {
					eve.target.gotoAndStop(2);
				}
			}

			function onBtnEffectOut(eve):void {
				if (! eve.target.isSelected) {
					eve.target.gotoAndStop(1);
				}
			}

			function onBtnEffectDown(eve):void {
				if (! eve.target.isSelected) {
					eve.target.gotoAndStop(3);
				}
			}
		}

	}
}