﻿package com
{
	import flash.display.MovieClip;
	import flash.display.Shape;
	import flash.display.Graphics;
	
	import flash.net.URLLoader;
	import flash.net.URLRequest;
	import flash.geom.Rectangle;
	
	import flash.events.Event;
	import flash.events.MouseEvent;
	
	import flash.text.TextField;
	import flash.text.TextFormat;
	import flash.text.AntiAliasType;
	import flash.text.TextFormatAlign;
	import flash.utils.getDefinitionByName;
	import flash.text.Font;
	public class NumberLine_Patterns extends MovieClip
	{
		private var XMLObj:XML=new XML();
		private var NumbersArray:Array=new Array();
		private var SHNBtn:showhidenumbersBtn=new showhidenumbersBtn();
		private var DragObj:MovieClip=new MovieClip();
		private var SelectedObj:MovieClip=new MovieClip();
		private var ClipsArray:Array=new Array();
		private var LinesArray:Array=new Array();
		private var HighlightLine:MovieClip=new MovieClip();
		private var NumberBtnsArray:Array=new Array();
		private var CurrentPattern:Number=0;
		private var showBtnClicked:Boolean=false;
		
		private var sw:Number=760;
		private var sh:Number=420;
			
		public function NumberLine_Patterns()
		{
			LoadActivityXML();
		}
		private function LoadActivityXML():void
		{
			var LoaderObj:URLLoader=new URLLoader();
			LoaderObj.load(new URLRequest("xml/NTO4_4.xml"));
			LoaderObj.addEventListener(Event.COMPLETE, onXMLLoaded);
		}
		private function onXMLLoaded(e:Event):void
		{
			XMLObj=XML(e.target.data);
			addChild(HighlightLine);
			
			//AddBottomPanel();
			AddHorizontalLine();
			AddVerticalLines();
			AddShowHideNumbersBtn();
			AddNumberButtons();
			AddRemoveNumberBtns();
			AddResetBtn();
			AddFrog();
		}
		private function AddBottomPanel():void
		{
			var sh:Shape=new Shape();
			var g:Graphics=sh.graphics;
			g.lineStyle(XMLObj.BottomPanel.@linethickness,XMLObj.BottomPanel.@linecolor);
			g.drawRect(0,0,XMLObj.BottomPanel.@width,XMLObj.BottomPanel.@height);
			addChild(sh);
			sh.x=XMLObj.BottomPanel.@xpos;
			sh.y=XMLObj.BottomPanel.@ypos;
		}
		private function AddHorizontalLine():void
		{
			////////////////////Draw Horizontal Line/////////////////
			var HLine:Shape=new Shape();
			HLine.graphics.lineStyle(XMLObj.HorizontalLine.@thickness,XMLObj.HorizontalLine.@color);
			HLine.graphics.moveTo(0,0);
			HLine.graphics.lineTo(XMLObj.HorizontalLine.@width,0);
			
			///////////////Draw arrowheads//////////////////////
			HLine.graphics.beginFill(XMLObj.HorizontalLine.@fillColor);
			HLine.graphics.moveTo(-5,0);
			HLine.graphics.lineTo(0,-5);
			HLine.graphics.lineTo(0,5);
			HLine.graphics.lineTo(-5,0);
			
			
			HLine.graphics.moveTo(Number(XMLObj.HorizontalLine.@width)+5,0);
			HLine.graphics.lineTo(Number(XMLObj.HorizontalLine.@width),-5);
			HLine.graphics.lineTo(Number(XMLObj.HorizontalLine.@width),5);
			HLine.graphics.lineTo(Number(XMLObj.HorizontalLine.@width)+5,0);
			
			HLine.graphics.endFill();
			
			addChild(HLine);
			
			HLine.x=XMLObj.HorizontalLine.@xpos;
			HLine.y=XMLObj.HorizontalLine.@ypos;
		}
		
		private function fnDragFrog(eve:MouseEvent):void{
			eve.currentTarget.startDrag(false,new Rectangle(0, 0, 700, 480));
			eve.currentTarget.addEventListener(MouseEvent.MOUSE_UP, fnStopFrogDrag);
			stage.addEventListener(MouseEvent.MOUSE_UP, fnStopFrogDrag);
		}
		
		private function fnStopFrogDrag(eve:MouseEvent):void{
			eve.currentTarget.stopDrag();
			eve.currentTarget.removeEventListener(MouseEvent.MOUSE_UP, fnStopFrogDrag);
			stage.removeEventListener(MouseEvent.MOUSE_UP, fnStopFrogDrag);
		}
		private function AddFrog():void{
			var f:MovieClip=new frog();
			addChild(f);
			f.x=Number(XMLObj.HorizontalLine.@xpos);
			f.y=Number(XMLObj.HorizontalLine.@ypos)-f.height-4;
			f.addEventListener(MouseEvent.MOUSE_DOWN, fnDragFrog);
		}
		
		private function AddVerticalLines():void
		{
			var NumLines:Number=Number(XMLObj.VerticalLines.@count);
			var StartX:Number=Number(XMLObj.VerticalLines.@startXpos);
			var StartY:Number=Number(XMLObj.VerticalLines.@startYpos);
			for(var i:int=0;i<NumLines;i++)
			{
				var VLine:MovieClip=new MovieClip();
				VLine.name="line_"+(i+1);
				VLine.id=i;
				LinesArray.push(VLine);
				
				var g:Graphics=VLine.graphics;
				g.lineStyle(Number(XMLObj.VerticalLines.@thickness));
				g.moveTo(0,0);
				g.lineTo(0,XMLObj.VerticalLines.@height);
				VLine.x=StartX;
				VLine.y=StartY;				
				addChild(VLine);
				
				var Txt:TextField=CreateTextField();
				addChild(Txt);
				Txt.htmlText=""+i;
				Txt.x=StartX-Txt.width/2;
				Txt.y=StartY+Number(XMLObj.VerticalLines.@height)+5;
				NumbersArray.push(Txt);
				Txt.visible=false;
				
				StartX+=Number(XMLObj.VerticalLines.@gap);
			}
		}
		private function AddShowHideNumbersBtn():void
		{
			addChild(SHNBtn);
			
			
			SHNBtn.x=XMLObj.Buttons.ShowHideNumbers.@xpos;
			SHNBtn.y=XMLObj.Buttons.ShowHideNumbers.@ypos;
			//SHNBtn.mouseChildren=false;
			//SHNBtn.buttonMode=true;
			SHNBtn.show_btn.visible=true;
			SHNBtn.hide_btn.visible=false;
			SHNBtn.hide_btn.addEventListener(MouseEvent.CLICK,ShowHideNumbers);
			SHNBtn.show_btn.addEventListener(MouseEvent.CLICK, ShowHideNumbers);
			SHNBtn.show_btn.dispatchEvent(new MouseEvent(MouseEvent.CLICK));
		}
		private function AddNumberButtons():void
		{
			var range=XMLObj.Buttons.NumberBtns.@range;
			var arr=XMLObj.Buttons.NumberBtns.@range.split("-");
			var StartNo=Number(arr[0]);
			var EndNo=Number(arr[1]);
			var StartX:Number=Number(XMLObj.Buttons.NumberBtns.@startXpos);
			var StartY:Number=Number(XMLObj.Buttons.NumberBtns.@startYpos);
			var TF:TextFormat=new TextFormat();
			TF.size=Number(XMLObj.Buttons.NumberBtns.@fontSize);
			TF.color=Number(XMLObj.Buttons.NumberBtns.@color);
			for(var i:int=StartNo;i<=EndNo;i++)
			{
				var Btn:numberBtn=new numberBtn();
				Btn.name="Btn_"+i;
				var Txt=Btn.getChildByName("txt");
				Txt.htmlText=""+i;
				Txt.setTextFormat(TF);
				
				Btn.x=StartX;
				Btn.y=StartY;
				StartX+=Number(XMLObj.Buttons.NumberBtns.@gap)+Btn.width;
				//Btn.mouseChildren=false;
				Btn.txt.mouseEnabled=false;
				Btn.buttonMode=true;				
				addChild(Btn);
				Btn.addEventListener(MouseEvent.CLICK,ShowPatterns);
				NumberBtnsArray.push(Btn);
			}
		}
		private function AddRemoveNumberBtns():void
		{
			var Btn1:addNumberBtn=new addNumberBtn();
			var Btn2:removeNumberBtn=new removeNumberBtn();
			
			Btn1.name="add";
			Btn2.name="remove";
			
			Btn1.x=XMLObj.Buttons.AddNumber.@xpos;
			Btn1.y=XMLObj.Buttons.AddNumber.@ypos;
			
			Btn2.x=XMLObj.Buttons.RemoveNumber.@xpos;
			Btn2.y=XMLObj.Buttons.RemoveNumber.@ypos;
			
			addChild(Btn1);
			addChild(Btn2);
			
			Btn1.mouseChildren=false;
			Btn1.addEventListener(MouseEvent.CLICK,CreateNumber);
			
			Btn2.mouseChildren=false;
			Btn2.mouseEnabled=false;
			Btn2.alpha=0.5;
			Btn2.addEventListener(MouseEvent.CLICK,RemoveNumber);
		}
		private function AddResetBtn():void
		{			
			//reset_btn.x=XMLObj.Buttons.ResetBtn.@xpos;
			//reset_btn.y=XMLObj.Buttons.ResetBtn.@ypos;
			reset_btn.addEventListener(MouseEvent.CLICK,reset);		
		}
		private function CreateTextField():TextField
		{
			var TxtFld:TextField=new TextField();
			TxtFld.name="txt";
			TxtFld.type="dynamic";
			TxtFld.selectable=false;
			TxtFld.multiline=false;	
			TxtFld.autoSize="left";
			
			TxtFld.antiAliasType=AntiAliasType.ADVANCED;
			
			var TF:TextFormat=new TextFormat();
			
			var FontC=getDefinitionByName(XMLObj.Words.@FontId) as Class;
			var newFont:Font=new FontC();
			
			TF.font=newFont.fontName;	
			TF.size=XMLObj.Words.@FontSize;
			TF.color=XMLObj.Words.@FontColor;

			TxtFld.defaultTextFormat=TF;	
			TxtFld.embedFonts=true;
			
			return TxtFld;
			
		}
		private function CreateMC():MovieClip
		{
			var mc:MovieClip=new MovieClip();
			var TxtFld:TextField=new TextField();
			TxtFld.name="txt";
			TxtFld.type="input";
			TxtFld.selectable=true;
			TxtFld.multiline=false;			
			TxtFld.maxChars=2;
			TxtFld.restrict="0-9";
			TxtFld.width=XMLObj.Words.@width;
			TxtFld.height=XMLObj.Words.@height;
			
			TxtFld.antiAliasType=AntiAliasType.ADVANCED;
			
			var TF:TextFormat=new TextFormat();
			
			var FontC=getDefinitionByName(XMLObj.Words.@FontId) as Class;
			var newFont:Font=new FontC();
			
			TF.font=newFont.fontName;	
			TF.size=XMLObj.Words.@FontSize;
			TF.color=XMLObj.Words.@FontColor;
			TF.align=TextFormatAlign.CENTER;

			TxtFld.defaultTextFormat=TF;	
			TxtFld.embedFonts=true;
			
			var sh:Shape=new Shape();
			sh.graphics.lineStyle(1,0x000000);
			sh.graphics.beginFill(0xffffff,1);
			sh.graphics.drawRect(0,0,TxtFld.width+2,TxtFld.height+2);
			sh.graphics.endFill();
			
			TxtFld.x=TxtFld.y=1;
			mc.addChild(sh);
			mc.addChild(TxtFld);
			
			mc.buttonMode=true;
			return mc;
			
		}
		private function ShowHideNumbers(e:MouseEvent=null):void
		{
			var Btn=SHNBtn;		
			for(var i:int=0;i<NumbersArray.length;i++)
			{
				if(Btn.show_btn.visible)
				{
					showBtnClicked=true;
					if(CurrentPattern==0)
					{
						NumbersArray[i].visible=true;	
					}else
					{
						if(i*CurrentPattern<NumbersArray.length)
						{
							NumbersArray[i*CurrentPattern].visible=true;	
						}
					}
				}
				if(Btn.hide_btn.visible)
				{
					showBtnClicked=false;
					NumbersArray[i].visible=false;
				}
			}
			if(Btn.show_btn.visible)
			{
				Btn.show_btn.visible=false;
				Btn.hide_btn.visible=true;
			}
			else if(Btn.hide_btn.visible)
			{
				Btn.show_btn.visible=true;
				Btn.hide_btn.visible=false;
			}
		}
		private function ShowPatterns(e:MouseEvent):void
		{
			var tar=e.currentTarget;
			var Btn=SHNBtn;		
			var TF:TextFormat=new TextFormat();
			TF.color=Number(XMLObj.Buttons.NumberBtns.@color);
			
			for(var i:int=0;i<NumberBtnsArray.length;i++)
			{
				NumberBtnsArray[i].gotoAndStop(1);
				var txt=NumberBtnsArray[i].getChildByName("txt");
				txt.mouseEnabled=false;
				txt.setTextFormat(TF);
			}
			tar.gotoAndStop(2);
			txt=tar.getChildByName("txt");
			TF.color=Number(XMLObj.Buttons.NumberBtns.@selectedColor);
			txt.setTextFormat(TF);
			
			var Num:Number=Number(tar.name.split("_")[1]);
			CurrentPattern=Num;
			HighlightLine.graphics.clear();
			for(i=0;i<NumbersArray.length;i++)
			{
				NumbersArray[i].visible=false;
			}
			for(i=0;i<LinesArray.length;i++)
			{
				if((LinesArray[i].id*Num)<LinesArray.length)
				{
					var mc=LinesArray[(LinesArray[i].id*Num)];
					var g:Graphics=HighlightLine.graphics;
					g.beginFill(0xffdd00,1);
					g.drawRect(mc.x-7.5,mc.y-2.5,15,mc.height+5);
					g.endFill();
					
					if(showBtnClicked)
					{
						NumbersArray[i*Num].visible=true;
					}
				}
				
			}
			
		}
		private function CreateNumber(e:MouseEvent):void
		{
			if(ClipsArray.length<LinesArray.length)
			{
				var Btn=e.currentTarget;
				var mc=CreateMC();
				mc.index=ClipsArray.length;
				addChild(mc);
				mc.x=Btn.x+(Btn.width-mc.width)/2;
				mc.y=Btn.y-mc.height-15;
				SelectedObj=mc;
				HighlightIt(mc);
				ClipsArray.push(mc);
				mc.addEventListener(MouseEvent.MOUSE_DOWN,DragIt);
			}
			if(ClipsArray.length==LinesArray.length)
			{
				var AB=getChildByName("add");
				AB.mouseEnabled=false;
				AB.alpha=0.5;
			}
		}
		private function RemoveNumber(e:MouseEvent):void
		{
			var RB=getChildByName("remove");
			RB.mouseEnabled=false;
			RB.alpha=0.5;
			
			var AB=getChildByName("add");
			AB.mouseEnabled=true;
			AB.alpha=1;
				
			if(SelectedObj)
			{
				for(var i:int=0;i<ClipsArray.length;i++)
				{
					if(ClipsArray[i].index==SelectedObj.index)
					{
						ClipsArray.splice(SelectedObj.index,1);
						break;
					}
				}
				for(i=0;i<ClipsArray.length;i++)
				{
					ClipsArray[i].index=i;
				}
				removeChild(SelectedObj);
				SelectedObj=new MovieClip();
			}
		}
		private function DragIt(e:MouseEvent):void
		{
			var tar=e.currentTarget;
			DragObj=tar;
			SelectedObj=tar;
			HighlightIt(DragObj);
			setChildIndex(DragObj,numChildren-1);
			DragObj.startDrag(false,new Rectangle(0,0,sw-DragObj.width,sh-DragObj.height));
			DragObj.addEventListener(MouseEvent.MOUSE_UP,DropIt);
			stage.addEventListener(MouseEvent.MOUSE_UP,DropIt);
		}
		private function DropIt(e:MouseEvent):void
		{
			if(DragObj)
			{
				DragObj.removeEventListener(MouseEvent.MOUSE_UP,DropIt);
				stage.removeEventListener(MouseEvent.MOUSE_UP,DropIt);
				DragObj.stopDrag();
				DragObj=new MovieClip();
			}
		}
		private function HighlightIt(me:MovieClip):void
		{
			var RB=getChildByName("remove");
			RB.mouseEnabled=true;
			RB.alpha=1;
			
			for(var i:int=0;i<ClipsArray.length;i++)
			{
				if(ClipsArray[i].getChildByName("hlt"))
				{
					ClipsArray[i].removeChild(ClipsArray[i].getChildByName("hlt"));
				}
			}
			if(!me.getChildByName("hlt"))
			{
				var sh:Shape=new Shape();
				sh.name="hlt";
				var g:Graphics=sh.graphics;
				g.lineStyle(2,0xed1a24);
				g.drawRect(0,0,me.width,me.height);
				me.addChild(sh);
			}
		}
		public function reset(e:MouseEvent):void
		{
			CurrentPattern=0;
			showBtnClicked=false;
			SHNBtn.show_btn.visible=false;
			SHNBtn.hide_btn.visible=true;
			ShowHideNumbers();
			for(var i:int=0;i<ClipsArray.length;i++)
			{
				removeChild(ClipsArray[i]);
			}	
			var TF:TextFormat=new TextFormat();
			TF.color=Number(XMLObj.Buttons.NumberBtns.@color);
			for(i=0;i<NumberBtnsArray.length;i++)
			{
				NumberBtnsArray[i].gotoAndStop(1);
				var txt=NumberBtnsArray[i].getChildByName("txt");
				txt.mouseEnabled=false;
				txt.setTextFormat(TF);
			}
			ClipsArray=new Array();
			HighlightLine.graphics.clear();
			
			var RB=getChildByName("remove");
			RB.mouseEnabled=false;
			RB.alpha=0.5;
			
			var AB=getChildByName("add");
			AB.mouseEnabled=true;
			AB.alpha=1;
		}
	}
}