﻿package com{	
	import flash.display.MovieClip;
	import flash.events.MouseEvent;
	import flash.geom.ColorTransform;
	import flash.net.URLLoader;
	import flash.net.URLRequest;
	import flash.events.Event;
	import flash.display.Stage;
	
	public class HundredsChart extends MovieClip{
		
		private var gridBoxX:Number;
		private var gridBoxY:Number;
		private var gridsMC:MovieClip;		
		private var gridBox:gridBoxMc;
		private var X:Number = 10;
		private var Y:Number = 10;
		private var count:Number = 0;
		private var mcColorTransform:ColorTransform;
		private var color:uint = 0xffdd00;
		private var XMLData:XML;
		private var countBy_Btn:countByBtn;
		private var textEntMC:textEnterMC;
		private var clrPickerMC:colorPickerMC;
		private var shwMC:showMC;
		private var startIndex:Number = 0;
		private var endIndex:Number = 0;
		private var gridColor:Array = new Array();
		private var colorPicked:String = "yellow";
		private var cntByClick:Boolean = false;
		
		private var sw:Number=720;
		private var sh:Number=460;
		
		public function HundredsChart(){
			
			var xmlLoader:URLLoader = new URLLoader();
			xmlLoader.load(new URLRequest("xml/hundredcards.xml"));
			xmlLoader.addEventListener(Event.COMPLETE, fnLoadXML)
		}
		
		//loading xml
		private function fnLoadXML(eve:Event):void{
			stage.stageFocusRect = false; //To disable yellow highlight around movieclips and buttons in tab press
			XMLData = new XML(eve.target.data);
			gridBoxX = XMLData.gridPosition.@X;
			gridBoxY = XMLData.gridPosition.@Y;
			startIndex = 1;
			endIndex = 10;
			fnGenerateGrids();
			fnAddButtons();			
		}
		
		//adding buttons,events for the buttons and aligning buttons
		private function fnAddButtons():void{			
			countBy_Btn = new countByBtn;
			addChild(countBy_Btn);
			countBy_Btn.x = XMLData.buttonsPosition.pointerCountBy.@X;
			countBy_Btn.y = XMLData.buttonsPosition.pointerCountBy.@Y;
			countBy_Btn.name = "countByBtn";
			//btnEnable(pointerCntByMC.pointerBtn);
			//btnEnable(pointerCntByMC.countByBtn);
			countBy_Btn.addEventListener(MouseEvent.CLICK, fnShowTextEnterMC);
			
			textEntMC = new textEnterMC;
			addChild(textEntMC);
			textEntMC.x = XMLData.buttonsPosition.enter.@X;
			textEntMC.y = XMLData.buttonsPosition.enter.@Y;
			textEntMC.name = "textEntMC";
			//btnEnable(textEntMC.enterBtn);
			textEntMC.enterBtn.addEventListener(MouseEvent.CLICK, fnDisplayMultiples);
			textEntMC.visible = false;
			
			clrPickerMC = new colorPickerMC;
			addChild(clrPickerMC);
			clrPickerMC.x = XMLData.buttonsPosition.colorPalette.@X;
			clrPickerMC.y = XMLData.buttonsPosition.colorPalette.@Y;
			clrPickerMC.name = "clrPickerMC";
			for(var i:int=0;i<3;i++)
			{
				clrPickerMC["hi"+i].visible=false;
			}
			clrPickerMC["hi1"].visible=true;
			clrPickerMC.red_mc.addEventListener(MouseEvent.CLICK, fnChangeGridColorCode);
			clrPickerMC.blue_mc.addEventListener(MouseEvent.CLICK, fnChangeGridColorCode);
			clrPickerMC.yellow_mc.addEventListener(MouseEvent.CLICK, fnChangeGridColorCode);
			
			shwMC = new showMC;
			addChild(shwMC);
			shwMC.x = XMLData.buttonsPosition.show.@X;
			shwMC.y = XMLData.buttonsPosition.show.@Y;
			shwMC.name = "shwMC";
			//btnEnable(shwMC.show_0_99_Btn);
			//btnEnable(shwMC.show_1_100_Btn);
			shwMC.show_1_100_Btn.visible = false;
			shwMC.show_0_99_Btn.addEventListener(MouseEvent.CLICK, fnChangeNumbers);
			shwMC.show_1_100_Btn.addEventListener(MouseEvent.CLICK, fnChangeNumbers);
			
			reset_btn.addEventListener(MouseEvent.CLICK, reset);
			//stage.addEventListener(MouseEvent.MOUSE_MOVE,restrictPointer);
		}
		/*private function restrictPointer(e:MouseEvent):void
		{
			var mc=getChildByName("pointerMC");
			if(mc)
			{
				if(mouseX<50 || mouseX>sw || mouseY<0 || mouseY>sh)
				{
					mc.visible=false;
				}else
				{
					mc.visible=true;
				}
			}
		}*/
		private function reset(eve:MouseEvent):void{
			var btnName:String;
			if(shwMC.show_0_99_Btn.visible){
				btnName = "show_1_100_Btn";
			}else{
				btnName = "show_0_99_Btn";
			}
			fnRemoveGrids();
			var btnNameArr:Array = btnName.split("_");
			startIndex = Number(btnNameArr[1]);
			endIndex = Math.floor(Number(btnNameArr[2])/10);
			resetAll();						
		}
		
		//Hide/Unhide textinput and enter button
		private function fnShowTextEnterMC(eve:MouseEvent):void{
			if(textEntMC.visible){
				textEntMC.visible = false;
			}else{
				textEntMC.visible = true;
			}
		}
		//Displays grid from 0-99 or 1-100 based on button clicked
		private function fnChangeNumbers(eve:MouseEvent):void{
			if(shwMC.show_0_99_Btn.visible){
				shwMC.show_0_99_Btn.visible = false;
				shwMC.show_1_100_Btn.visible = true;
			}else{
				shwMC.show_0_99_Btn.visible = true;
				shwMC.show_1_100_Btn.visible = false;
			}
			fnRemoveGrids();
			var btnName:Array = eve.target.name.split("_");
			startIndex = Number(btnName[1]);
			endIndex = Math.floor(Number(btnName[2])/10);
			resetAll();
		}
		
		private function resetAll():void{						
			count = 0;
			X = 10;
			Y = 10;
			color = 0xffdd00;
			colorPicked = "yellow";
			//clrPickerMC.highlightMC.x = 50.2;
			//clrPickerMC.highlightMC.y = 6.1;
			for(var i:int=0;i<3;i++)
			{
				clrPickerMC["hi"+i].visible=false;
			}
			clrPickerMC["hi1"].visible=true;
			gridColor = [];
			textEntMC.visible = false;
			fnGenerateGrids();
		}
		
		//removes main clip and child clips
		private function fnRemoveGrids():void{
			for(var i:Number = startIndex; i <= gridsMC.numChildren; i++){
				gridsMC.removeChild(gridsMC.getChildByName("gridBox_" + i));
			}
			removeChild(gridsMC);
		}
		
		//Changes the grid color with the selected color
		private function fnChangeGridColorCode(eve:MouseEvent):void{
			var btnColor:Array = eve.target.name.split("_");
			for(var i:int=0;i<3;i++)
			{
				clrPickerMC["hi"+i].visible=false;
			}
			if(btnColor[0] == "red"){
				color = 0xFF0000;
				colorPicked = "red";
				clrPickerMC["hi0"].visible=true;
			}else if(btnColor[0] == "blue"){
				color = 0x0000FF;
				colorPicked = "blue";
				clrPickerMC["hi2"].visible=true;
			}else{
				color = 0xffdd00;
				colorPicked = "yellow";
				clrPickerMC["hi1"].visible=true;
			}
			
			/*clrPickerMC.highlightMC.x = eve.target.x;
			clrPickerMC.highlightMC.y = eve.target.y;*/
		}
		
		//Adding mousechildren and buttonmode for movie clip
		private function btnEnable(btn:*):void{
			btn.mouseChildren = false;
			btn.buttonMode = true;
		}
		
		//Generates grid 
		private function fnGenerateGrids():void{
			gridsMC = new MovieClip();
			addChild(gridsMC);
			count = startIndex;
			for(var i:Number = startIndex; i <= endIndex; i++){				
				for(var j:Number = startIndex; j <= endIndex; j++){
					gridBox = new gridBoxMc;
					gridsMC.addChild(gridBox);					
					gridBox.name = "gridBox_" + count;
					gridBox.id=count;
					gridBox.clickcount=0;
					gridColor.push(" ");
					gridBox.doubleClickEnabled=true;
					gridBox.addEventListener(MouseEvent.CLICK, fnChngClickGridColor);
					gridBox.addEventListener(MouseEvent.DOUBLE_CLICK, hideText);
					gridBox.mouseChildren = false;
					gridBox.buttonMode = true;
					gridBox.numberTxt.text = String(count);
					if((i == startIndex && j == startIndex) || (j == startIndex)){
						if(i == startIndex && j == startIndex){
							gridBox.x = X;
							gridBox.y = Y;
						}else{
							gridBox.x = 10;
							gridBox.y = Y;
						}
						
					}else{
						X = X + gridBox.width - 2;
						gridBox.x = X;
						gridBox.y = Y;
					}
					count++;
				}
				Y = Y + gridBox.height - 2;
				X = 10;
			}
			count--;
			gridsMC.x = gridBoxX;
			gridsMC.y = gridBoxY;
		}
		
		//change grid box color of selected box
		private function fnChngClickGridColor(eve:MouseEvent):void{
			var clipName:String = eve.target.name;
			fnChangeClipColor(clipName.split("_")[1]);
		}
		private function hideText(e:MouseEvent):void
		{
			var tar=e.target;
			tar.clickcount++;
			trace(tar.clickcount);
			tar.numberTxt.text="";
			if(tar.clickcount%2==0)
			{
				tar.numberTxt.text=tar.id;
			}
		}
		//Highlight color of multiples of text entered
		private function fnDisplayMultiples(eve:MouseEvent):void{
			cntByClick = true;
			var multipleValue:Number = Number(textEntMC.countTextMC.counterTxt.text);
			trace("multipleValue: ", textEntMC.countTextMC.counterTxt.text, "::", multipleValue);
			if(multipleValue==0&&shwMC.show_1_100_Btn.visible)
			{
				fnChangeClipColor(multipleValue);
			}
			for(var i:Number = startIndex; i <= count; i++){
				if(i%multipleValue == 0){
					if(i != 0){
						fnChangeClipColor(i);
					}
				}
			}
		}
		
		//Change color of grid
		private function fnChangeClipColor(index:Number):void{
			var clip:MovieClip = new MovieClip();
			clip = gridsMC.getChildByName("gridBox_" + index) as MovieClip;
			if(gridColor[index-1] == " "){
				gridColor[index-1] = colorPicked;
				if(colorPicked == "yellow"){
					color = 0xffdd00;
				}else if(colorPicked == "red"){
					color = 0xed1c24;
				}else{
					color = 0x005fae;
				}
			}else{
				if((gridColor[index-1] == "yellow" && colorPicked == "blue") || (gridColor[index-1] == "blue" && colorPicked == "yellow")){
					color = 0x41AD49;
					gridColor[index-1] = "green";
				}else if(gridColor[index-1] == "green" && colorPicked == "blue"){
					color = 0x996600;
					gridColor[index-1] = "brown";
				}else if((gridColor[index-1] == "red" && colorPicked == "yellow") || (gridColor[index-1] == "yellow" && colorPicked == "red")){
					color = 0xf58220;
					gridColor[index-1] = "orange";
				}else if((gridColor[index-1] == "red" && colorPicked == "blue") || (gridColor[index-1] == "blue" && colorPicked == "red")){
					color = 0x782B90;
					gridColor[index-1] = "lavender";
				}else if((gridColor[index-1] == "orange" && colorPicked == "yellow") || (gridColor[index-1] == "orange" && colorPicked == "red") || (gridColor[index-1] == "orange" && colorPicked == "blue") || (gridColor[index-1] == "lavender" && colorPicked == "yellow") || (gridColor[index-1] == "lavender" && colorPicked == "red") || (gridColor[index-1] == "lavender" && colorPicked == "blue")){
					color = 0x996600;
					gridColor[index-1] = "brown";
				}else if((gridColor[index-1] == "brown" && colorPicked == "yellow") || (gridColor[index-1] == "brown" && colorPicked == "red") || (gridColor[index-1] == "brown" && colorPicked == "blue")){
					if(colorPicked == "yellow"){
						color = 0xffdd00;
					}else if(colorPicked == "blue"){
						color = 0x005fae;
					}else{
						color = 0xed1c24;
					}
					//color = 0xff9900;
					gridColor[index-1] = colorPicked;
				}else if((gridColor[index-1] == "yellow" && colorPicked == "yellow") || (gridColor[index-1] == "red" && colorPicked == "red") || (gridColor[index-1] == "blue" && colorPicked == "blue")){
					if(!cntByClick){
						cntByClick = false;
						color = 0xffffff;
						gridColor[index-1] = " ";
					}
				}
			}			
			mcColorTransform = clip.transform.colorTransform;
			mcColorTransform.color = color;	
			clip.gridBoxBgMC.transform.colorTransform = mcColorTransform;
		}
		
		
	}
}