﻿package com
{
	import flash.display.MovieClip;
	import flash.display.Sprite;
	import flash.display.Shape;
	import flash.display.Graphics;
	
	import flash.net.URLLoader;
	import flash.net.URLRequest;
	import flash.geom.Rectangle;
	import flash.filters.DropShadowFilter;
	
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.events.TextEvent;
	
	import flash.text.TextField;
	import flash.text.TextFormat;
	import flash.text.AntiAliasType;
	import flash.text.TextFormatAlign;
	import flash.utils.getDefinitionByName;
	import flash.text.Font;
	import flash.geom.Matrix;
	
	
	public class Arrays extends MovieClip
	{
		private var XMLObj:XML=new XML();
		private var RandomArrayMC:MovieClip=new MovieClip();
		private var TotalItems:Number=new Number();
		private var LB:LargerBtn=new LargerBtn();
		private var SB:SmallerBtn=new SmallerBtn();
		private var RB:RotateBtn=new RotateBtn();
		private var Feedback:MovieClip;
		
		private var sw:Number=760;
		private var sh:Number=420;
		
		public function Arrays()
		{
			LoadActivityXML();
		}
		private function LoadActivityXML():void
		{
			var LoaderObj:URLLoader=new URLLoader();
			LoaderObj.load(new URLRequest("xml/NTO4_10.xml"));
			LoaderObj.addEventListener(Event.COMPLETE, onXMLLoaded);
		}
		private function onXMLLoaded(e:Event):void
		{
			XMLObj=XML(e.target.data);
			
			addChild(RandomArrayMC);
			//AddBottomPanel();
			AddAllButtons();
			AddCounter();
			AddResetBtn();
			
		}
		private function AddBottomPanel():void
		{
			var sh:Shape=new Shape();
			var g:Graphics=sh.graphics;
			g.lineStyle(XMLObj.BottomPanel.@linethickness,XMLObj.BottomPanel.@linecolor);
			g.drawRect(0,0,XMLObj.BottomPanel.@width,XMLObj.BottomPanel.@height);
			addChild(sh);
			sh.x=XMLObj.BottomPanel.@xpos;
			sh.y=XMLObj.BottomPanel.@ypos;
		}
		private function AddAllButtons():void
		{
			var RABtn:RandomArrayBtn=new RandomArrayBtn();
			RABtn.x=XMLObj.Buttons.RandomArray.@xpos;
			RABtn.y=XMLObj.Buttons.RandomArray.@ypos;
			addChild(RABtn);
			RABtn.addEventListener(MouseEvent.CLICK,CreateRandomArray);
			
			var DimBtn:DimMC=new DimMC();
			DimBtn.name="DimensionMC";
			DimBtn.x=XMLObj.Buttons.ArrayDim.@xpos;
			DimBtn.y=XMLObj.Buttons.ArrayDim.@ypos;
			addChild(DimBtn);
			DimBtn.txt1.maxChars=2;
			DimBtn.txt1.restrict="0-9";
			DimBtn.txt2.maxChars=2;
			DimBtn.txt2.restrict="0-9";
			DimBtn.txt1.addEventListener(Event.CHANGE,onTextInput);
			DimBtn.txt2.addEventListener(Event.CHANGE,onTextInput);
			
			var SABtn:SetArrayBtn=new SetArrayBtn();
			SABtn.name="SetArrayBtn";
			SABtn.x=XMLObj.Buttons.SetArray.@xpos;
			SABtn.y=XMLObj.Buttons.SetArray.@ypos;
			addChild(SABtn);
			SABtn.mouseEnabled=false;
			SABtn.alpha=0.5;
			SABtn.addEventListener(MouseEvent.CLICK,SetArray);
			
			var SHCCBtn:ShowHideCoverCardBtn=new ShowHideCoverCardBtn();
			SHCCBtn.name="showHideCardBtn";
			SHCCBtn.x=XMLObj.Buttons.ShowHideCoverCard.@xpos;
			SHCCBtn.y=XMLObj.Buttons.ShowHideCoverCard.@ypos;
			addChild(SHCCBtn);
			SHCCBtn.hideCardBtn.visible=false;
			SHCCBtn.hideCardBtn.addEventListener(MouseEvent.CLICK,hideCard);
			SHCCBtn.showCardBtn.mouseEnabled=false;
			SHCCBtn.showCardBtn.alpha=0.5;
			SHCCBtn.showCardBtn.addEventListener(MouseEvent.CLICK,showCard);
			
			
			LB.x=XMLObj.Buttons.Larger.@xpos;
			LB.y=XMLObj.Buttons.Larger.@ypos;
			addChild(LB);
			LB.mouseEnabled=false;
			LB.alpha=0.5;
			LB.addEventListener(MouseEvent.CLICK,enlargeIt);
						
			
			SB.x=XMLObj.Buttons.Smaller.@xpos;
			SB.y=XMLObj.Buttons.Smaller.@ypos;
			addChild(SB);
			SB.mouseEnabled=false;
			SB.alpha=0.5;
			SB.addEventListener(MouseEvent.CLICK,shrinkIt);
			
			
			RB.x=XMLObj.Buttons.Rotate.@xpos;
			RB.y=XMLObj.Buttons.Rotate.@ypos;
			addChild(RB);
			RB.mouseEnabled=false;
			RB.alpha=0.5;
			RB.addEventListener(MouseEvent.CLICK,rotateIt);
		}
		private function AddCounter():void
		{
			var Txt:TextField=CreateInputText();
			Txt.name="Counter";
			Txt.selectable=false;
			Txt.width=XMLObj.Count.@width;
			Txt.height=XMLObj.Count.@height;
			Txt.x=XMLObj.Count.@xpos;
			Txt.y=XMLObj.Count.@ypos;
			Txt.maxChars=XMLObj.Count.@maxChars;
			Txt.restrict="0-9";
			addChild(Txt);
			Txt.addEventListener(Event.CHANGE,validateIt);
		}
		private function AddResetBtn():void
		{				
			/*var res:ResetBtn=new ResetBtn();
			addChild(res);
			reset_btn.x=XMLObj.Buttons.Reset.@xpos;
			reset_btn.y=XMLObj.Buttons.Reset.@ypos;*/
			reset_btn.addEventListener(MouseEvent.CLICK,Reset);		
		}
		private function CreateInputText():TextField
		{
			var TxtFld:TextField=new TextField();
			TxtFld.name="txt";
			TxtFld.type="input";
			TxtFld.border=true;
			TxtFld.multiline=false;	
			
			TxtFld.antiAliasType=AntiAliasType.ADVANCED;
			
			var TF:TextFormat=new TextFormat();
			TF.align=TextFormatAlign.CENTER;
			
			var FontC=getDefinitionByName(XMLObj.Count.@FontId) as Class;
			var newFont:Font=new FontC();
			
			TF.font=newFont.fontName;	
			TF.size=XMLObj.Count.@FontSize;
			TF.color=XMLObj.Count.@FontColor;

			TxtFld.defaultTextFormat=TF;	
			TxtFld.embedFonts=true;
			
			return TxtFld;
			
		}
		private function CreateTextField():TextField
		{
			var TxtFld:TextField=new TextField();
			TxtFld.name="txt";
			TxtFld.type="dynamic";
			TxtFld.selectable=false;
			TxtFld.multiline=false;	
			TxtFld.autoSize="left";
			
			TxtFld.antiAliasType=AntiAliasType.ADVANCED;
			
			var TF:TextFormat=new TextFormat();
			
			var FontC=getDefinitionByName(XMLObj.Words.@FontId) as Class;
			var newFont:Font=new FontC();
			
			TF.font=newFont.fontName;	
			TF.size=XMLObj.Words.@FontSize;
			TF.color=XMLObj.Words.@FontColor;

			TxtFld.defaultTextFormat=TF;	
			TxtFld.embedFonts=true;
			
			return TxtFld;
			
		}
		private function CreateRandomArray(e:MouseEvent=null):void
		{
			ResetTextFields();
			statusShowCard(true);
			
			var Col:Number=randomRange(2,10);
			var Row:Number=randomRange(2,10);
			
			for(var i:int=RandomArrayMC.numChildren-1;i>=0;i--)
			{
				RandomArrayMC.removeChildAt(i);
			}			
			
			TotalItems=Col*Row;
			GenerateIt(Col,Row);
		}
		private function GenerateIt(c:Number,r:Number):void
		{
			var cntr=getChildByName("Counter");
			cntr.selectable=true;
			cntr.text="";
			
			try
			{
				if(Feedback)
				{
					removeChild(Feedback);
				}
			}catch(e:Error)
			{
			}
			
			var StartX:Number=Number(XMLObj.ArrayItems.@xpos);
			var StartY:Number=Number(XMLObj.ArrayItems.@ypos);
			for(var i:int=0;i<c;i++)
			{
				for(var j:int=0;j<r;j++)
				{
					var child:CircleMC=new CircleMC();
					RandomArrayMC.addChild(child);
					
					child.x=StartX;
					child.y=StartY;
					StartY+=child.height+Number(XMLObj.ArrayItems.@gap);
				}
				StartX+=child.width+Number(XMLObj.ArrayItems.@gap);
				StartY=Number(XMLObj.ArrayItems.@ypos);
			}
		}
		private function randomRange(minNum:Number, maxNum:Number):Number  
		{  
			return (Math.floor(Math.random() * (maxNum - minNum + 1)) + minNum);  
		} 
		private function onTextInput(e:Event):void
		{
			var tar=getChildByName("DimensionMC");
			var Btn=getChildByName("SetArrayBtn");
			if(tar.txt1.text!="" && tar.txt2.text!="")
			{
				Btn.mouseEnabled=true;
				Btn.alpha=1;
			}else
			{
				Btn.mouseEnabled=false;
				Btn.alpha=0.5;
			}			
		}
		private function SetArray(e:MouseEvent):void
		{
			var Btn=e.currentTarget;
			Btn.mouseEnabled=false;
			Btn.alpha=0.5;
			statusShowCard(true);
			
			//RemoveWarning();
			
			var tar=getChildByName("DimensionMC");
			if((Number(tar.txt1.text)<2 || Number(tar.txt1.text)>10) || (Number(tar.txt2.text)<2 || Number(tar.txt2.text)>10))
			{
				/*var txt:TextField=CreateTextField();
				txt.name="warningTxt";
				txt.htmlText=XMLObj.WarningText;
				addChild(txt);
				txt.x=tar.x-tar.width/1.4;
				txt.y=tar.y-1.4*tar.height;
				tar.txt1.text="";
				tar.txt2.text="";*/
				var Col:Number=Number(tar.txt1.text);
				var Row:Number=Number(tar.txt2.text);
				if(Number(tar.txt1.text)<2)
				{
					Col=2;
				}
				if(Number(tar.txt1.text)>10)
				{
					Col=10;
				}
				if(Number(tar.txt2.text)<2)
				{
					Row=2;
				}
				if(Number(tar.txt2.text)>10)
				{
					Row=10;
				}
				TotalItems=Col*Row;
				GenerateIt(Col,Row);
				tar.txt1.text=""+Col;
				tar.txt2.text=""+Row;
				
			}else
			{
				Col=Number(tar.txt1.text);
				Row=Number(tar.txt2.text);
				
				for(var i:int=RandomArrayMC.numChildren-1;i>=0;i--)
				{
					RandomArrayMC.removeChildAt(i);
				}			
				
				TotalItems=Col*Row;
				GenerateIt(Col,Row);
			}
		}
		private function ResetTextFields():void
		{
			//RemoveWarning();
			
			ResetInutFields();
		}
		private function RemoveWarning():void
		{
			/*var warningTxt=getChildByName("warningTxt");
			if(warningTxt)
			{
				removeChild(warningTxt);
			}*/
		}
		private function ResetInutFields():void
		{
			var tar=getChildByName("DimensionMC");
			tar.txt1.text="";
			tar.txt2.text="";
		}
		private function statusShowCard(bool:Boolean):void
		{
			var shcard=getChildByName("showHideCardBtn");
			shcard.showCardBtn.mouseEnabled=bool;
			shcard.showCardBtn.alpha=(bool)?1:0.5;
		}
		private function showCard(E:MouseEvent):void
		{
			var shcard=getChildByName("showHideCardBtn");
			shcard.hideCardBtn.visible=true;
			shcard.showCardBtn.visible=false;			
			
			var card:MovieClip=new MovieClip();
			card.name="card";
			
			var sh:Sprite=new Sprite();
			sh.name="child";
			var g:Graphics=sh.graphics;
			g.lineStyle(XMLObj.card.@linethickness,XMLObj.card.@lineColor);
			g.beginFill(XMLObj.card.@fillcolor,1);
			g.drawRect(-Number(XMLObj.card.@width)/2,-Number(XMLObj.card.@height)/2,Number(XMLObj.card.@width),Number(XMLObj.card.@height));
			g.endFill();
			
			card.addChild(sh);
			addChild(card);
			card.x=Number(XMLObj.card.@xpos)+Number(XMLObj.card.@width)/2;		
			card.y=Number(XMLObj.card.@ypos)+Number(XMLObj.card.@height)/2;	
			
			var ch:MovieClip=new MovieClip();
			ch.name="selchild";
			var gr:Graphics=ch.graphics;
			gr.lineStyle(1,0xf58220,1);
			gr.drawRect(-card.width/2+1,-card.height/2+1,card.width-2,card.height-2);			
			
			var SF:DropShadowFilter=new DropShadowFilter();
			SF.blurX=XMLObj.card.@blurX;
			SF.blurY=XMLObj.card.@blurY;
			SF.angle=XMLObj.card.@shadowAngle;
			SF.distance=XMLObj.card.@shadowDistance;
			SF.color=XMLObj.card.@shadowColor;
			SF.alpha=XMLObj.card.@shadowAlpha;
			
			card.mouseChildren=false;
			card.filters=[SF];
			
			card.addEventListener(MouseEvent.MOUSE_DOWN,ControlIt);			
			
			card.addChild(ch);
			//ch.visible=false;
			LB.mouseEnabled=true;
			LB.alpha=1;
			SB.mouseEnabled=true;
			SB.alpha=1;
			RB.mouseEnabled=true;
			RB.alpha=1;
			
		}
		private function ControlIt(e:MouseEvent):void
		{
			var card=getChildByName("card");
			try
			{
				if(card.getChildByName("selchild"))
				{
					var child=card.getChildByName("selchild");
					child.visible=true;
				}
			}catch(e:Error)
			{
				
			}			
			
			
			LB.mouseEnabled=true;
			LB.alpha=1;
			SB.mouseEnabled=true;
			SB.alpha=1;
			RB.mouseEnabled=true;
			RB.alpha=1;
			
			card.startDrag(false,new Rectangle(Number(XMLObj.card.@width)/2,Number(XMLObj.card.@height)/2,sw-Number(XMLObj.card.@width),sh-Number(XMLObj.card.@height)));
			setChildIndex(card,numChildren-1);
			card.addEventListener(MouseEvent.MOUSE_UP,dropIt);
			stage.addEventListener(MouseEvent.MOUSE_UP,removeControls);
		}
		private function dropIt(e:MouseEvent):void
		{
			var card=getChildByName("card");
			card.stopDrag();
			card.removeEventListener(MouseEvent.MOUSE_UP,dropIt);
		}
		private function removeControls(e:MouseEvent):void
		{
			var tar=e.target;
			if(tar.name==null)
			{
				var card=getChildByName("card");
				card.stopDrag();
				card.removeEventListener(MouseEvent.MOUSE_UP,dropIt);
				try
				{
					if(card.getChildByName("selchild"))
					{
						var child=card.getChildByName("selchild");
						child.visible=false;
					}
				}catch(e:Error)
				{
				}
				LB.mouseEnabled=false;
				LB.alpha=0.5;
				SB.mouseEnabled=false;
				SB.alpha=0.5;
				RB.mouseEnabled=false;
				RB.alpha=0.5;
				stage.removeEventListener(MouseEvent.MOUSE_UP,removeControls);
			}
		}
		private function hideCard(e:MouseEvent):void
		{
			var card=getChildByName("card");
			removeChild(card);
			
			var shcard=getChildByName("showHideCardBtn");
			shcard.hideCardBtn.visible=false;
			shcard.showCardBtn.visible=true;
			
			statusShowCard(true);
			SB.mouseEnabled=false;
			SB.alpha=0.5;
			LB.mouseEnabled=false;
			LB.alpha=0.5;
			RB.mouseEnabled=false;
			RB.alpha=0.5;
		}
		private function enlargeIt(e:MouseEvent):void
		{
			
			var card=getChildByName("card");
			if(card.scaleX<1.6)
			{
				card.scaleX+=0.2;
				card.scaleY+=0.2;
			}
		}
		private function shrinkIt(e:MouseEvent):void
		{
			
			var card=getChildByName("card");
			if(card.scaleX>0.6)
			{
				card.scaleX-=0.2;
				card.scaleY-=0.2;
			}
		}
		private function rotateIt(e:MouseEvent):void
		{
			var card=getChildByName("card");
			card.rotation+=10;
		}
		private function validateIt(e:Event):void
		{
			var tar=e.currentTarget;
			try
			{
				if(Feedback)
				{
					removeChild(Feedback);
				}
			}catch(e:Error)
			{
			}
			if(tar.text!="")
			{
				if(Number(tar.text)==TotalItems)
				{
					Feedback=new correct();
				}else
				{
					Feedback=new wrong();
				}
				Feedback.x=XMLObj.Feedback.@xpos;
				Feedback.y=XMLObj.Feedback.@ypos;
				addChild(Feedback);
			}
		}
		private function Reset(e:MouseEvent):void
		{
			
			var card=getChildByName("card");
			if(card){
				removeChild(card);
			}
			try
			{
				if(Feedback)
				{
					removeChild(Feedback);
				}
			}catch(e:Error)
			{
			}
			SB.mouseEnabled=false;
			SB.alpha=0.5;
			LB.mouseEnabled=false;
			LB.alpha=0.5;
			RB.mouseEnabled=false;
			RB.alpha=0.5;
			var shcard=getChildByName("showHideCardBtn");
			shcard.hideCardBtn.visible=false;
			shcard.showCardBtn.visible=true;
			CreateRandomArray();
		}
	}
}