﻿package com
{
	import flash.display.MovieClip;
	import flash.display.Shape;
	import flash.display.Graphics;
	
	import flash.net.URLLoader;
	import flash.net.URLRequest;
	import flash.geom.Rectangle;
	
	import flash.events.Event;
	import flash.events.MouseEvent;
	
	import flash.text.TextField;
	import flash.text.TextFormat;
	import flash.text.AntiAliasType;
	import flash.text.TextFormatAlign;
	import flash.utils.getDefinitionByName;
	import flash.text.Font;
	public class PlaceValue_Millions extends MovieClip
	{
		private var XMLObj:XML=new XML();
		private var DragObj:MovieClip=new MovieClip();
		private var DropElementsArray:Array=new Array();
		private var DropObjArray:Array=new Array();
		private var Counter:Number=0;
		private var RowObjectsArray:Array=new Array();
		
		private var sw:Number=760;
		private var sh:Number=500;
			
		public function PlaceValue_Millions()
		{
			LoadActivityXML();
		}
		private function LoadActivityXML():void
		{
			var LoaderObj:URLLoader=new URLLoader();
			LoaderObj.load(new URLRequest("xml/NTO4_5.xml"));
			LoaderObj.addEventListener(Event.COMPLETE, onXMLLoaded);
		}
		private function onXMLLoaded(e:Event):void
		{
			XMLObj=XML(e.target.data);
			
			//AddBottomPanel();
			CreateTable();
			CreateDrops();
			CreateDrags();
			AddResetBtn();
			
		}
		private function AddBottomPanel():void
		{
			var sh:Shape=new Shape();
			var g:Graphics=sh.graphics;
			g.lineStyle(XMLObj.BottomPanel.@linethickness,XMLObj.BottomPanel.@linecolor);
			g.drawRect(0,0,XMLObj.BottomPanel.@width,XMLObj.BottomPanel.@height);
			addChild(sh);
			sh.x=XMLObj.BottomPanel.@xpos;
			sh.y=XMLObj.BottomPanel.@ypos;
		}
		private function CreateTable():void
		{
			//////////////////////////Create Number columns///////////////////
			var NumColumns:Number=XMLObj.Table.Columns1.Column.length();
			var StartX:Number=Number(XMLObj.Table.Columns1.@xpos);
			var StartY:Number=Number(XMLObj.Table.Columns1.@ypos);			
			for(var i:int=0;i<NumColumns;i++)
			{
				var sh:Shape=new Shape();
				var g:Graphics=sh.graphics;
				g.lineStyle(XMLObj.CommonColumnProperties.@linethickness,XMLObj.CommonColumnProperties.@lineColor);
				g.beginFill(XMLObj.CommonColumnProperties.@fillcolor);
				g.drawRect(0,0,XMLObj.Table.Columns1.Column[i].@width,XMLObj.CommonColumnProperties.@columnHeight);
				g.endFill();
				addChild(sh);
				
				g.beginFill(XMLObj.CommonColumnProperties.@headercolor);
				g.drawRect(0,0,XMLObj.Table.Columns1.Column[i].@width,XMLObj.CommonColumnProperties.@headerheight);
				g.endFill();
				
				var txt=CreateTextField();
				addChild(txt);				
				
				txt.x=StartX;
				txt.y=StartY;
				txt.htmlText=XMLObj.Table.Columns1.Column[i].@Title;			
				
				sh.x=StartX;
				StartX+=Number(XMLObj.Table.Columns1.Column[i].@width);
				sh.y=StartY;
			}
			//////////////////Create Number rows and dots///////////////////////
			var rowCnt:Number=Number(XMLObj.Table.Rows.@count);
			var rowWidth:Number=StartX-Number(XMLObj.Table.Columns1.@xpos);
			var rowHht:Number=(Number(XMLObj.CommonColumnProperties.@columnHeight)-Number(XMLObj.CommonColumnProperties.@headerheight))/rowCnt;
			StartX=XMLObj.Table.Columns1.@xpos;
			StartY=Number(XMLObj.Table.Columns1.@ypos)+Number(XMLObj.CommonColumnProperties.@headerheight);
			for(i=0;i<rowCnt;i++)
			{
				var ro:Shape=new Shape();
				var gr:Graphics=ro.graphics;
				gr.lineStyle(XMLObj.Table.Rows.@linethickness,XMLObj.Table.Rows.@lineColor);
				gr.beginFill(XMLObj.Table.Rows.@fillcolor,0);
				gr.drawRect(0,0,rowWidth,rowHht);
				gr.endFill();
				addChild(ro);
				
				ro.x=StartX;
				ro.y=StartY;			
				StartY+=rowHht;
				
				var dotObj:dot=new dot();
				dotObj.x=Number(StartX)+rowWidth+10;
				dotObj.y=Number(StartY)-15;
				addChild(dotObj);
				
				var xpos:Number=dotObj.x+10;
			}
			
			//////////////////////Create column 2 and titles////////////////////////////////
			NumColumns=XMLObj.Table.Columns2.Column.length();
			StartX=xpos;
			StartY=Number(XMLObj.Table.Columns1.@ypos);
			
			for(i=0;i<NumColumns;i++)
			{
				sh=new Shape();
				g=sh.graphics;
				g.lineStyle(XMLObj.CommonColumnProperties.@linethickness,XMLObj.CommonColumnProperties.@lineColor);
				g.beginFill(XMLObj.CommonColumnProperties.@fillcolor);
				g.drawRect(0,0,XMLObj.Table.Columns2.Column[i].@width,XMLObj.CommonColumnProperties.@columnHeight);
				g.endFill();
				addChild(sh);
				
				g.beginFill(XMLObj.CommonColumnProperties.@headercolor);
				g.drawRect(0,0,XMLObj.Table.Columns2.Column[i].@width,XMLObj.CommonColumnProperties.@headerheight);
				g.endFill();
				
				txt=CreateTextField();
				addChild(txt);
				
				
				txt.x=StartX;
				txt.y=StartY;
				txt.htmlText=XMLObj.Table.Columns2.Column[i].@Title;			
				
				sh.x=StartX;
				StartX+=Number(XMLObj.Table.Columns2.Column[i].@width);
				sh.y=StartY;
			}
			
			///////////////////Create row2///////////////////////
			rowWidth=StartX-xpos;
			StartX=xpos;
			StartY=Number(XMLObj.Table.Columns1.@ypos)+Number(XMLObj.CommonColumnProperties.@headerheight);
			for(i=0;i<rowCnt;i++)
			{
				ro=new Shape();
				gr=ro.graphics;
				gr.lineStyle(XMLObj.Table.Rows.@linethickness,XMLObj.Table.Rows.@lineColor);
				gr.beginFill(XMLObj.Table.Rows.@fillcolor,0);
				gr.drawRect(0,0,rowWidth,rowHht);
				gr.endFill();
				addChild(ro);
				
				ro.x=StartX;
				ro.y=StartY;			
				StartY+=rowHht;
			}
			
		}
		private function CreateDrops():void
		{
			var DropStartX:Number=Number(XMLObj.Table.Columns1.@xpos);
			var DropStartY:Number=Number(XMLObj.Table.Columns1.@ypos)+Number(XMLObj.CommonColumnProperties.@headerheight);
			var DropHeight:Number=Number(XMLObj.CommonColumnProperties.@columnHeight)-Number(XMLObj.CommonColumnProperties.@headerheight);
			var NumColumns_1:Number=XMLObj.Table.Columns1.Column.length();
			for(var i:int=0;i<NumColumns_1;i++)
			{
				var sh:MovieClip=new MovieClip();
				sh.name="drop_"+i;
				sh.index=i;
				sh.graphics.beginFill(0xffffff,0);
				sh.graphics.drawRect(0,0,Number(XMLObj.Table.Columns1.Column[i].@width),DropHeight);
				sh.graphics.endFill();
				addChild(sh);
				
				sh.x=DropStartX;
				sh.y=DropStartY;
				DropStartX+=Number(XMLObj.Table.Columns1.Column[i].@width);
				
				var Obj:Object=new Object();
				Obj.DropsArray=new Array();
				DropElementsArray.push(Obj);
				DropObjArray.push(sh);
				
				var ins:Object=new Object();
				ins.RowArray=new Array();
				RowObjectsArray.push(ins);
			}
			
			DropStartX+=20;
			var NumColumns_2:Number=XMLObj.Table.Columns2.Column.length();
			for(i=0;i<NumColumns_2;i++)
			{
				sh=new MovieClip();
				sh.name="drop_"+(i+NumColumns_1);
				sh.index=(i+NumColumns_1);
				sh.graphics.beginFill(0xffffff,0);
				sh.graphics.drawRect(0,0,Number(XMLObj.Table.Columns2.Column[i].@width),DropHeight);
				sh.graphics.endFill();
				addChild(sh);
				
				sh.x=DropStartX;
				sh.y=DropStartY;
				DropStartX+=Number(XMLObj.Table.Columns2.Column[i].@width);
				
				Obj=new Object();
				Obj.DropsArray=new Array();
				DropElementsArray.push(Obj);
				DropObjArray.push(sh);
				
				ins=new Object();
				ins.RowArray=new Array();
				RowObjectsArray.push(ins);
			}
		}
		private function CreateDrags():void
		{
			var StartNo:Number=Number(XMLObj.Numbers.@range.split("-")[0]);
			var EndNo:Number=Number(XMLObj.Numbers.@range.split("-")[1]);
			var StartX:Number=Number(XMLObj.Numbers.@xpos);
			var StartY:Number=Number(XMLObj.Numbers.@ypos);
			
			for(var i:int=StartNo;i<=EndNo;i++)
			{
				var mc:MovieClip=CreateMC(""+i);
				mc.index=i;
				Counter++;
				addChild(mc);
				mc.x=StartX;
				mc.y=StartY;
				mc.xpos=mc.x;
				mc.ypos=mc.y;
				StartX+=Number(XMLObj.Numbers.@gap)+mc.width;
				
				mc.mouseChildren=false;
				mc.buttonMode=true;
				mc.addEventListener(MouseEvent.MOUSE_DOWN,DragIt);
			}
		}
		private function AddResetBtn():void
		{			
			/*addChild(res);
			res.x=XMLObj.ResetBtn.@xpos;
			res.y=XMLObj.ResetBtn.@ypos;*/
			
			var showResultBtn = getChildByName("showResultBtn")
			showResultBtn.gotoAndStop(2);
			var white = getChildByName("_white");
			
			showResultBtn.addEventListener(MouseEvent.CLICK, function() {
				
					setChildIndex(white, (numChildren - 1));
					if(showResultBtn.currentFrame == 1){
						showResultBtn.gotoAndStop(2);
						white.visible = false;
					}else{
						showResultBtn.gotoAndStop(1);
						white.visible = true;
					}
					//showHideResult();
				});
			
			showResultBtn.dispatchEvent(new MouseEvent(MouseEvent.CLICK));
			reset_btn.addEventListener(MouseEvent.CLICK,Reset);		
		}
		private function CreateTextField():TextField
		{
			var TxtFld:TextField=new TextField();
			TxtFld.name="txt";
			TxtFld.type="dynamic";
			TxtFld.selectable=false;
			TxtFld.multiline=false;	
			TxtFld.autoSize="left";
			
			TxtFld.antiAliasType=AntiAliasType.ADVANCED;
			
			var TF:TextFormat=new TextFormat();
			
			var FontC=getDefinitionByName(XMLObj.Words.@FontId) as Class;
			var newFont:Font=new FontC();
			
			TF.font=newFont.fontName;	
			TF.size=XMLObj.Words.@FontSize;
			TF.color=XMLObj.Words.@FontColor;

			TxtFld.defaultTextFormat=TF;	
			TxtFld.embedFonts=true;
			
			return TxtFld;
			
		}
		private function CreateMC(Str:String):MovieClip
		{
			var mc:MovieClip=new MovieClip();
			var TxtFld:TextField=new TextField();
			TxtFld.name="txt";
			TxtFld.autoSize="left";
			TxtFld.htmlText=Str;
			TxtFld.selectable=false;
			TxtFld.multiline=false;	
			
			TxtFld.antiAliasType=AntiAliasType.ADVANCED;
			
			var TF:TextFormat=new TextFormat();
			
			var FontC=getDefinitionByName(XMLObj.Numbers.@FontId) as Class;
			var newFont:Font=new FontC();
			
			TF.font=newFont.fontName;	
			TF.size=XMLObj.Numbers.@FontSize;
			TF.color=XMLObj.Numbers.@FontColor;
			TF.align=TextFormatAlign.CENTER;

			TxtFld.setTextFormat(TF);	
			TxtFld.embedFonts=true;
			
			var sh:MovieClip=new MovieClip();
			//sh.graphics.lineStyle(0x000000,1);
			sh.graphics.beginFill(0xffffff,0);
			sh.graphics.drawRect(2,6,TxtFld.textWidth,TxtFld.textHeight-10);
			sh.graphics.endFill();
			
			
			mc.addChild(sh);
			mc.addChild(TxtFld);
			
			TxtFld.mouseEnabled=false;
			mc.hitArea=sh;
			mc.mouseChildren=false;
			mc.buttonMode=true;
			return mc;
			
		}
		private function Duplicate(drag:MovieClip):MovieClip
		{
			Counter++;
			var mc:MovieClip=CreateMC(""+drag.index);
			mc.index=Counter;
			addChild(mc);
			mc.x=drag.x;
			mc.y=drag.y;
			mc.xpos=mc.x;
			mc.ypos=mc.y;
			
			mc.mouseChildren=false;
			mc.buttonMode=true;
			mc.addEventListener(MouseEvent.MOUSE_DOWN,DragDuplicate);
			return mc;
		}
		private function DragIt(e:MouseEvent):void
		{
			var tar=e.currentTarget;
			DragObj=Duplicate(tar);
			DragObj.startDrag(false,new Rectangle(0,0,sw-DragObj.width,sh-DragObj.height));
			setChildIndex(DragObj,numChildren-1);			
			
			DragObj.addEventListener(MouseEvent.MOUSE_UP,DropIt);
			stage.addEventListener(MouseEvent.MOUSE_UP,DropIt);
			
			for(var i:int=0;i<DropElementsArray.length;i++)
			{
				for(var j:int=0;j<DropElementsArray[i].DropsArray.length;j++)
				{
					if(DropElementsArray[i].DropsArray[j].index==DragObj.index)
					{
						DropElementsArray[i].DropsArray.splice(j,1);
						break;
					}
				}
				var rowCnt:Number=Number(XMLObj.Table.Rows.@count);
				for(var k:int=0;k<rowCnt;k++)
				{
					if(RowObjectsArray[i].RowArray[k] && RowObjectsArray[i].RowArray[k].index==DragObj.index)
					{
						RowObjectsArray[i].RowArray[k]=undefined;
					}
				}
			}
		}
		private function DragDuplicate(e:MouseEvent):void
		{
			var tar=e.currentTarget;
			DragObj=tar;
			DragObj.startDrag(false,new Rectangle(0,0,stage.stageWidth-DragObj.width,stage.stageHeight-DragObj.height));
			setChildIndex(DragObj,numChildren-1);			
			
			DragObj.addEventListener(MouseEvent.MOUSE_UP,DropIt);
			stage.addEventListener(MouseEvent.MOUSE_UP,DropIt);
			
			for(var i:int=0;i<DropElementsArray.length;i++)
			{
				for(var j:int=0;j<DropElementsArray[i].DropsArray.length;j++)
				{
					if(DropElementsArray[i].DropsArray[j].index==DragObj.index)
					{
						DropElementsArray[i].DropsArray.splice(j,1);
						break;
					}
				}	
				var rowCnt:Number=Number(XMLObj.Table.Rows.@count);
				for(var k:int=0;k<rowCnt;k++)
				{
					if(RowObjectsArray[i].RowArray[k] && RowObjectsArray[i].RowArray[k].index==DragObj.index)
					{
						RowObjectsArray[i].RowArray[k]=undefined;
					}
				}
			}
		}
		private function DropIt(e:MouseEvent):void
		{
			if(DragObj)
			{
				DragObj.stopDrag();
				DragObj.removeEventListener(MouseEvent.MOUSE_UP,DropIt);
				stage.removeEventListener(MouseEvent.MOUSE_UP,DropIt);
				var cnt:Number = 0;
				
				var _white = getChildByName("_white");
				for(var i:int=0;i<DropObjArray.length;i++)
				{
					
					
					
					
					if(DragObj.hitTestObject(DropObjArray[i]))
					{
						
						if (i == 0  ) {
							trace("ind0");
							if ( _white.visible == true)
							{
								DragObj.visible=false;
							
							}
							
						}
						
						
						
							cnt++;
							DropElementsArray[i].DropsArray.push(DragObj);
							break;
						
						
					}
				}
				ArrangeItems(DragObj);
				try
				{
					if(cnt==0)
					{
						
						removeChild(DragObj);
						
					}
				}catch(e:Error)
				{ 
				}
				DragObj=new MovieClip();
			}
		}
		private function ArrangeItems(Obj:MovieClip):void
		{
			var rowCnt:Number=Number(XMLObj.Table.Rows.@count);
			var rowHht:Number=(Number(XMLObj.CommonColumnProperties.@columnHeight)-Number(XMLObj.CommonColumnProperties.@headerheight))/rowCnt;
			var visit:Number=0;
			for(var i:int=0;i<DropElementsArray.length;i++)
			{
				var StartX:Number=DropObjArray[i].x;
				var StartY:Number=DropObjArray[i].y;
				var RowMinYArray:Array=new Array();
				var RowMaxYArray:Array=new Array();
				var RowMinXArray:Array=new Array();
				var RowMaxXArray:Array=new Array();
				for(var j:int=0;j<rowCnt;j++)
				{
					RowMinYArray.push(StartY);
					RowMinXArray.push(StartX);
					StartY+=rowHht;
					RowMaxYArray.push(StartY);
					RowMaxXArray.push(StartX+DropObjArray[i].width);
				}
				
				for(var k:int=0;k<rowCnt;k++)
				{
					if(((Obj.y+10)>=RowMinYArray[k] && (Obj.y+10)<=RowMaxYArray[k]) && (Obj.x>=RowMinXArray[k] && Obj.x<=RowMaxXArray[k]) )
					{	
						if(RowObjectsArray[i].RowArray[k])
						{							
							removeChild(RowObjectsArray[i].RowArray[k]);								
							for(var m:int=0;m<DropElementsArray[i].DropsArray.length;m++)
							{
								if(DropElementsArray[i].DropsArray[m].index==Obj.index)
								{		
									DropElementsArray[i].DropsArray.splice(m,1);
									break;
								}								
							}							
						}
						visit++;
						RowObjectsArray[i].RowArray[k]=Obj;
						Obj.x=StartX+(DropObjArray[i].width-Obj.width)/2;
						Obj.y=RowMaxYArray[k]-Obj.height;
						break;
					}
				}
			}
			if(visit==0)
			{
				removeChild(Obj);
			}
		}
		private function Reset(e:MouseEvent):void
		{
			for(var i:int=0;i<RowObjectsArray.length;i++)
			{
				for(var m:int=RowObjectsArray[i].RowArray.length;m>=0;m--)
				{
					try
					{
						if(RowObjectsArray[i].RowArray[m])
						{
							removeChild(RowObjectsArray[i].RowArray[m]);
						}
					}catch(e:Error)
					{
						
					}
				}
				RowObjectsArray[i].RowArray=new Array();
				DropElementsArray[i].DropsArray=new Array();
			}
		}
	}
}