﻿package com
{
	import flash.display.MovieClip;
	import flash.display.Shape;
	import flash.display.Graphics;
	import flash.display.Loader;
	
	import flash.net.URLLoader;
	import flash.net.URLRequest;
	import flash.geom.Rectangle;
	
	import flash.events.Event;
	import flash.events.MouseEvent;
	
	import flash.text.TextField;
	import flash.text.TextFormat;
	import flash.text.AntiAliasType;
	import flash.text.TextFormatAlign;
	import flash.utils.getDefinitionByName;
	import flash.text.Font;
	public class Poster extends MovieClip
	{
		private var XMLObj:XML=new XML();
		private var LoaderMC:preloader_mc=new preloader_mc();
		private var TotalImages:Number=0;
		private var LoadedImageCount:Number=0;
		private var RowsCount:Number=0;
		private var ColsCount:Number=0;
		
		private var sw:Number=760;
		private var sh:Number=530;
		
		public function Poster()
		{			
			LoadActivityXML();
		}
		private function LoadActivityXML():void
		{
			var LoaderObj:URLLoader=new URLLoader();
			LoaderObj.load(new URLRequest("xml/NTO4_9.xml"));
			LoaderObj.addEventListener(Event.COMPLETE, onXMLLoaded);
		}
		private function onXMLLoaded(e:Event):void
		{
			XMLObj=XML(e.target.data);
			
			FindTotalImages();
			CreatePosters();				
		}
		private function FindTotalImages():void
		{
			var Rows:Number=XMLObj.Posters.Poster.length();
			for(var i:int=0;i<Rows;i++)
			{
				var Cols:Number=XMLObj.Posters.Poster[i].Image.length();
				TotalImages+=Cols;
			}
		}
		private function LoadImages():void
		{
			//trace("in");
			if(LoadedImageCount<TotalImages)
			{
				var ImPath:String=XMLObj.Posters.Poster[RowsCount].Image[ColsCount].@url;		
			
				LoadImage(ImPath);
			}
			if(LoadedImageCount==TotalImages)
			{
				removeChild(LoaderMC);
			}
		}
		private function LoadImage(path:String):void
		{
			var LoaderObj:Loader=new Loader();
			LoaderObj.load(new URLRequest(path));
			LoaderObj.contentLoaderInfo.addEventListener(Event.COMPLETE,onImageLoaded);
		}
		private function onImageLoaded(e:Event):void
		{
			var tar=e.target.loader;
			var mc=tar.content;
			addChild(mc);
			mc.x=XMLObj.Posters.Poster[RowsCount].Image[ColsCount].@xpos;
			mc.y=XMLObj.Posters.Poster[RowsCount].Image[ColsCount].@ypos;
			
			var Txt:TextField=CreateTextField();
			Txt.htmlText=XMLObj.Posters.Poster[RowsCount].Image[ColsCount].@name;
			addChild(Txt);
			Txt.x=mc.x+(mc.width-Txt.width)/2;
			Txt.y=mc.y+mc.height+5;
			
			if(ColsCount==(XMLObj.Posters.Poster[RowsCount].Image.length()-1))
			{
				RowsCount++;
				ColsCount=0;
			}else
			{
				ColsCount++;
			}
			LoadedImageCount++;
			
			setChildIndex(LoaderMC,numChildren-1);
			
			var percentage:int = int((LoadedImageCount/TotalImages)*100);
			if ( percentage < 100 ) {
				LoaderMC.gotoAndStop(percentage);
				LoaderMC.txt.text = "loading..."+percentage+"%";
			} 
			
			LoadImages();
		}
		private function CreateTextField():TextField
		{
			var TxtFld:TextField=new TextField();
			TxtFld.name="txt";
			TxtFld.type="dynamic";
			TxtFld.selectable=false;
			TxtFld.multiline=false;	
			TxtFld.autoSize="left";
			
			TxtFld.antiAliasType=AntiAliasType.ADVANCED;
			
			var TF:TextFormat=new TextFormat();
			
			var FontC=getDefinitionByName(XMLObj.Words.@FontId) as Class;
			var newFont:Font=new FontC();
			
			TF.font=newFont.fontName;	
			TF.size=XMLObj.Words.@FontSize;
			TF.color=XMLObj.Words.@FontColor;

			TxtFld.defaultTextFormat=TF;	
			TxtFld.embedFonts=true;
			
			return TxtFld;
			
		}
		private function CreatePosters():void
		{
			var Poster:MovieClip=new MovieClip();
			var g:Graphics=Poster.graphics;
			g.lineStyle(XMLObj.Posters.@outlinethickness,XMLObj.Posters.@outlineColor);
			g.beginFill(XMLObj.Posters.@fillColor,1);
			g.drawRect(0,0,XMLObj.Posters.@width,XMLObj.Posters.@height);
			g.endFill();
			addChild(Poster);
			
			Poster.x=XMLObj.Posters.@xpos;
			Poster.y=XMLObj.Posters.@ypos;		
			
			var LineGap:Number=Number(XMLObj.Posters.@height)/XMLObj.Posters.Poster.length();
			var LineStartY:Number=Number(XMLObj.Posters.@lineY);
			
			for(var i:int=0;i<(XMLObj.Posters.Poster.length()-1);i++)
			{
				var Line:Shape=new Shape();
				g=Line.graphics;
				g.lineStyle(XMLObj.Posters.@linethickness,XMLObj.Posters.@linecolor);
				g.moveTo(0,0);
				g.lineTo(XMLObj.Posters.@width,0);
				addChild(Line);
				LineStartY+=LineGap;
				
				Line.x=XMLObj.Posters.@lineX;
				Line.y=LineStartY;					
			}	
			addChild(LoaderMC);
			LoaderMC.x=(sw)/2;
			LoaderMC.y=(sh)/2;
			
			LoadImages();
		}
		private function Reset(e:MouseEvent):void
		{
			
		}
	}
}